function [x,y]=min_g_r(f,a,b,err,min_o,varargin)
% function min_gr(f,a,b,err)
% Minimization of function f using golden ratio method over interval [a,b]
% f - string with the name of the function
% err - error 
% varargin dalsi argumenty fce f

if min_o
    znam=1;
else
    znam=-1;
end

if nargin<3
 error('min_g_r: too few arguments');
 end



if a>b p=a; a=b;b=p; end

x1=a; x4=b; h=x4-x1;

f1=znam*feval(f,x1,varargin{:}); f4=znam*feval(f,x4,varargin{:});

r=(sqrt(5)-1)/2;
p=r*h; x2=x4-p; x3=x1+p;

f2=znam*feval(f,x2,varargin{:}); f3=znam*feval(f,x3,varargin{:});

while x4-x1>err
 if f2<f3
  x4=x3; f4=f3;
  x3=x2; f3=f2;
  h=x4-x1;
  x2=x4-r*h;
  f2=znam*feval(f,x2,varargin{:});
  
 else
  x1=x2; f1=f2;
  x2=x3; f2=f3;
  h=x4-x1;
  x3=x1+r*h;
  f3=znam*feval(f,x3,varargin{:});
  
 end
end
x=(x4+x1)/2;

if nargout==2
y=znam*feval(f,x,varargin{:});
end

end
