function M=nwmatrix(X,h,x_net,K)
% function M=nwmatrix(X,h,x_net,kernel)
% This function counts smoothing matrix for Nadaraya-Watson estimatiors.
% X - data points
% h - bandwidth
% x_net  - in theese points will be counted the estimated function
% kernel - name of file containing kernel function; if this parameter is not
%          given, Epanechnikov kernel is used
% --------------------------------------------------------------------------
% For data values Y the estimated function m is given as m=M*Y

if nargin<3
 error('nwmatrix: Too litle input parameters, sorry.');
 return;
end
if nargin==3
 K=K_def('epan');
end
X=col(X);
[m,n]= size(X);
if n~=1
 error('nwmatrix: Wrong size of data vector.');
 return
end
x_net=row(x_net);
[M,N]=size(x_net);
if M~=1
 error('nwmatrix: Wrong size of mesh vector.');
 return
end
M=[];
for x=x_net
 pomx=X-x;
 w=K_val(K,(pomx/h))/h;
% w=feval(kernel,(pomx/h)/h);
 M=[M; w'/sum(w)];
 %M=[M; w'];
end
