function [x,y]=opt_osci(f,a,b,err,n_osc,min_o,varargin)
% Minimization of oscilatory function f over interval [a,b]
% n_osc - approximate number of oscilations 
% err - error 
% min_o - logical, true if minimum
% varargin dalsi argumenty fce f



if min_o
    znam=1;
else
    znam=-1;
end

if a>b 
    p=a;a=b;b=p; end

h=b-a;
h_min=h/(2*n_osc);

% initialisation
xx=[a, a+h/4, a+h/2, a+3*h/4,b];
ff=znam*feval(f,xx,varargin{:});


trend=(ff(2:5)>ff(1:4))-(ff(2:5)<ff(1:4));
% trend(i)=1  if f is increasing on [x(i),x(i+1)]
% trend(i)=-1 if f is decreasing on [x(i),x(i+1)]
n_ch=zeros(1,4); % number of no_change in trend

% main loop
ii=1;
x1=xx(1);
f1=ff(1);
% n_c=0; % number of no_change in trend
while x1<b
 x2=xx(ii+1);
 f2=ff(ii+1);
 xp=(x1+x2)/2;
 
  fp=znam*feval(f,xp,varargin{:});
 
% moving data
 np=length(xx);
 xx(ii+2:np+1)=xx(ii+1:np);
 xx(ii+1)=xp;
 ff(ii+2:np+1)=ff(ii+1:np);
 ff(ii+1)=fp;
 t1=(fp>f1)-(fp<f1);
 t2=(f2>fp)-(f2<fp);
 trend(ii+2:np)=trend(ii+1:np-1);
 trend(ii)=t1; trend(ii+1)=t2;
 n_ch(ii+2:np)=n_ch(ii+1:np-1);
 if t1*t2>0 % trend is the same
  n_c=n_ch(ii)+1;
  n_ch(ii)=n_c; n_ch(ii+1)=n_c;
  if n_c>=2 % trend was the same 3 times
   ii=ii+2;
   x1=x2;
   f1=f2;
  end
 else
  if xp-x1<h_min
   ii=ii+2;
   x1=x2;
   f1=f2;
  else
   n_ch(ii)=0; n_ch(ii+1)=0;
  end
 end
end % end of while

aa=[];
bb=[];
np=length(trend);
for ii=1:np-1
 if trend(ii)==-1 && trend(ii+1)>=0
  aa=[aa, xx(ii)]; bb=[bb, xx(ii+2)];
 end
end
if trend(1)>=0
 aa=[xx(1), aa];
 bb=[xx(2), bb];
end
if trend(np)<=0
 aa=[aa, xx(np)];
 bb=[bb, xx(np+1)];
end
n=length(aa);
xp=[];
yp=[];
for ii=1:n
   [x,y]=min_g_r(f,aa(ii),bb(ii),err,min_o,varargin{:});
 
 xp=[xp, x]; yp=[yp, y];
end
[y,ii]=min(yp);
x=xp(ii);
